#! /usr/bin/perl
#Name: R2-client.perl
#Project: R2
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 09.04.2012
#Copyright: (c) 2012 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Client script for R2-server.perl. Both scripts are used to operate a remote controlled rover and to do the picture upload from the webcam.

use strict;
use IO::Socket;

$|=1 ;

my $socket;
my $send_data = "";
my $received_data;
my $pic_count = 0;
my $file_in = "00000010.jpg";
my $char_in = "";
my $i;
my @file_info;
my $file_size = 0;
my $command_line = "";
my $char_temp = "";
my $command_start_time = 0;
my $command_stop_time = 0;
my $job_status = 0;
my $wait_count = 0;
my $driveDistance = 0;
my $cameraHeight = 0;
my $cameraAngle = 0;
my $last_pic_send = 0;
my $make_snapshot = 0;
my $last_watchdog_call = 0;
my $battery_status = 0;
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);



$socket = new IO::Socket::INET (
                                  PeerAddr  => 'www.XYZ.XX',
#                                  PeerAddr  => '192.168.1.2',
                                  PeerPort  =>  1000,
                                  Proto => 'tcp',
                               )
or die "Couldn't connect to Server\n";

$pic_count = 0;

$send_data = substr("Type your password here" . "                              ", 0, 33);
$socket->send($send_data, 33);


while (1 == 1){

  &WatchDogFile(0);

  if($job_status != 0){

#Use mplayer or ffmpeg to get a single image from the webcam. 10 pics are generated to give the wabcam some time to autoadjust the brightness.

    `killall -s SIGKILL ffmpeg`;
    `killall -s SIGKILL mplayer`;
    if($last_pic_send == 0 && $make_snapshot == 1){
      sleep(2);#Give the servos 2 seconds to ajust position
      #`./R2C1 v 255`;
      #`./R2C1 h 255`;
      #give the webcam 5 seconds to set the focus
      #$command_line = "ffmpeg -f video4linux2 -s 1920x1080 -r 5 -t 5 -qscale 5 -i /dev/video1 %08d.jpg";
      $command_line = "mplayer tv:// -tv driver=v4l2:device=/dev/video1:width=1280:height=720:outfmt=mjpeg:quality=50 -nosound -frames 10 -vo jpeg";
      print "command_line = '" . $command_line . "'\n";
      `$command_line`;
      $command_line = "";
    }
    else{
      if($last_pic_send == 1 && $make_snapshot == 1){
        $command_line = "ffmpeg -i $file_in -s 320x180 $file_in";
        print "command_line = '" . $command_line . "'\n";
        `$command_line`;
        $command_line = "";
      }
      else{
        $command_line = "mplayer tv:// -tv driver=v4l2:device=/dev/video1:width=320:height=180:outfmt=mjpeg:quality=50 -nosound -frames 10 -vo jpeg";
        #$command_line = "ffmpeg -f video4linux2 -s 320x180 -r 5 -t 3 -qscale 5 -i /dev/video1 %08d.jpg";
        print "command_line = '" . $command_line . "'\n";
        `$command_line`;
        $command_line = "";
#       `rm 00000023.jpg`;
#       `cp 00000010.jpg 00000023.jpg`;
      }
    }

    @file_info=stat($file_in);
    $file_size = $file_info[7];

    $send_data = "";

    $send_data = "File size = " . $file_size . "                    ";
    $send_data = substr($send_data, 0, 20);

    $socket->send($send_data, 20);
    print "'" . $send_data . "' Laenge String=" . length($send_data) . "\n";

    #Open image file and start transfer to server
    open(FILEIN, '<' . $file_in) || die "Can not open file $file_in: $!";
      $i = 0;
      $send_data = "";
      while(($char_in = getc(FILEIN)) ne "" && $file_size > 0){
        &WatchDogFile(0);
        $send_data = $send_data . $char_in;
        $i++;
        if($i == 1024 || $i == $file_size){
          if ($file_size < 1024){
            while(length($send_data)<1024){
              $send_data = $send_data . " ";
            }
            $socket->send($send_data, 1024);
            $send_data = "";
            $i = 0;
            $file_size = 0;
          }
          else{
            $socket->send($send_data, 1024);
            $send_data = "";
            $i = 0;
            $file_size -= 1024;
          }
        }
      }
    close(FILEIN);

    $pic_count++;

    print "File no. " . $pic_count . " sent, waiting for confirmation...\n";

    $socket->recv($received_data, 20, MSG_WAITALL);
    if(substr($received_data, 0, 16) eq "Received picture"){
      print "'" . $received_data . "'  ";
      print "...confirmed\n\n\n";
    }
    else{
      print "received_data = '" . $received_data . "'\n";
      &LogFile ("...confirmation of received picture failed!");
      die "...confirmation failed!\n";
    }
    #sleep(2);#Do nothing for 2 seconds to keep data transfer rate low (I still need bandwidth of my Internet connection for some other stuff).
  }#if($job_status != 0){

  if($command_start_time != 0){
    if(time()-$command_start_time < $command_stop_time){
      $send_data = "Busy                ";
      $socket->send($send_data, 20);
      print "Send:'" . $send_data . "'\n";
      if($make_snapshot == 1){
        $command_stop_time == 0;
      }
    }
    else{
      if($last_pic_send == 0){#send last pic after command finished
        $send_data = "Busy                ";
        $socket->send($send_data, 20);
        print "Send:'" . $send_data . "'\n";
        $last_pic_send = 1;
      }
      else{
        $command_line="./R2C1 bat";
        `$command_line`;
        $command_line="";
        &GetBatteryStatus();
        $send_data = substr("Job done   " . "000" . " + " . $battery_status . "   ", 0, 20);
        $socket->send($send_data, 20);
        print "Send:'" . $send_data . "'\n";
        print "\n\n\n\n\n\n\n\n\n\n\n\n\n";
        $command_start_time = 0;
        $job_status = 0;
        $last_pic_send = 0;
      }
    }
  }#if($command_start_time != 0){
  else{
    $command_line="./R2C1 bat";
    `$command_line`;
    $command_line="";
    &GetBatteryStatus();
    $send_data = substr("Waiting    " . "000" . " + " . $battery_status . "   ", 0, 20);
    $socket->send($send_data, 20);
    print "Send:'" . $send_data . "'\n";

    $received_data = "";
    $socket->recv($received_data, 20, MSG_WAITALL);
    print "received data:'" . $received_data . "'\n";

    while(substr($received_data, 0, 12) eq "Still alive?"){
      if($wait_count == 0){
        $command_line="./R2C1 v 70";                  #Initialize rover
        `$command_line`;
        $command_line="./R2C1 s 82";                  #Initialize rover
        `$command_line`;
        $command_line="./R2C1 l 0";                  #Initialize rover
        `$command_line`;
      }
      else{
        $command_line="./R2C1 O";                  #set rover in parking position
      }
      print "command_line = '" . $command_line . "'\n";
      `$command_line`;

      $wait_count ++;
      print "wait_count = $wait_count\n";
      $command_line="./R2C1 bat";
      `$command_line`;
      $command_line="";
      &GetBatteryStatus();
      $send_data="Yes!             " . $battery_status;
      $socket->send($send_data, 20);
      print "Send:'" . $send_data . "'\n";
      &WatchDogFile(0);
      $received_data = "";
      $socket->recv($received_data, 20, MSG_WAITALL);
      print "received_data = '" . $received_data . "'\n";
    }

    if(substr($received_data, 0, 5) eq "Comm="){
      $wait_count = 0;
      print "\n\nReceived command '" . $received_data . "'\n\n";

      if(substr($received_data, 6, 1) eq "2" | substr($received_data, 6, 1) eq "5"){#turn servo right
        $command_line="./R2C1 s 65";
      }
      if(substr($received_data, 6, 1) eq "1" | substr($received_data, 6, 1) eq "4"){#turn servo left
        $command_line="./R2C1 s 105";
      }
      if(substr($received_data, 6, 1) eq "0" | substr($received_data, 6, 1) eq "3"){#servo straight
        $command_line="./R2C1 s 82";
      }
      print "command_line = '" . $command_line . "'\n";
      `$command_line`;
      $command_line = "";


      $driveDistance = substr($received_data, 7, 2) * 25;
      if($driveDistance < 0 | $driveDistance > 255){
        print "driveDistance=$driveDistance out of range!\n";
        $driveDistance = 0;
      }


      if(substr($received_data, 6, 1) eq "0" | substr($received_data, 6, 1) eq "1" | substr($received_data, 6, 1) eq "2"){#Driving forward
        $command_line="./R2C1 f " . $driveDistance;
      }
      else{
        $command_line="./R2C1 b " . $driveDistance;
      }
      print "command_line = '" . $command_line . "'\n";
      `$command_line`;
      $command_line = "";
      $command_stop_time = 7 * $driveDistance / 255;
      if($make_snapshot == 1){
        $command_stop_time == 100;
      }

      if(substr($received_data, 13, 1) eq "0"){#Lights off
        $command_line="./R2C1 l 0";
      }
      if(substr($received_data, 13, 1) eq "1"){#Light low
        $command_line="./R2C1 l 20";
      }
      if(substr($received_data, 13, 1) eq "2"){
        $command_line="./R2C1 l 40";
      }
      if(substr($received_data, 13, 1) eq "3"){
        $command_line="./R2C1 l 90";
      }
      if(substr($received_data, 13, 1) eq "4"){#Full light
        $command_line="./R2C1 l 200";
      }
      print "command_line = '" . $command_line . "'\n";
      `$command_line`;
      $command_line = "";

      $cameraHeight = substr($received_data, 9, 2);
      if($cameraHeight < 1 | $cameraHeight > 3){
        print "cameraHeight=$cameraHeight out of range!\n";
        $cameraHeight = 2;
      }
      else{
        if($cameraHeight == 1){
          $command_line="./R2C1 h 2";
        }
        if($cameraHeight == 2){
          $command_line="./R2C1 h 1";
        }
        print "command_line = '" . $command_line . "'\n";
        `$command_line`;
        $command_line = "";
      }

      $cameraAngle = substr($received_data, 11, 2);
      if($cameraAngle < 0 | $cameraAngle > 15){
        print "cameraAngle=$cameraAngle out of range!\n";
        &LogFile("cameraAngle=$cameraAngle out of range!");
        $cameraAngle = 255;
      }
      else{
        $cameraAngle = sprintf("%.0f", 80 * $cameraAngle / 16 + 25);
        $command_line="./R2C1 v $cameraAngle";
        print "command_line = '" . $command_line . "'\n";
        `$command_line`;
        $command_line = "";
      }


      if(substr($received_data, 14, 1) eq "1"){#make snapshot
        $make_snapshot = 1;
      }
      else{
        $make_snapshot = 0;
      }
      $job_status = 1;
      $command_start_time=time();
    }#if(substr($received_data, 0, 5) eq "Comm="){
    else{
      &LogFile("Invalid commandline! >$received_data<, probably incorrect password.");
      die "Invalid commandline! >$received_data<, probably incorrect password.\n"
    }
  }


}#while (1 == 1)


print $pic_count . " files sent\n";

$send_data = "...ferddisch!                    " . "\n";
$socket->send($send_data, 20);

close $socket;

#++++++++++++++++++++++++ Read file with battery status ++++++++++++++++++++++++++++++++
sub GetBatteryStatus{
  open(DATEIIN, '<BatteryStatus.txt') || die 'Could not open BatteryStatus.txt';
    $char_temp = <DATEIIN>;
  close (DATEIIN);
  $battery_status = substr($char_temp, 17, 3);
}

#++++++++++++++++++++++++ LogFile ++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("R2-client.log");

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 10000){
    `mv R2-server.log R2-client01.log`
  }

  open(LOGFILE, ">> R2-client.log") || die "Can not open file 'R2-client.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

#++++++++++++++++++++++ WatchDogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub WatchDogFile{#Print a timestamp into a file to show watchdog-client.perl that script is still alive
  if(time() - $last_watchdog_call > 10){
    open(WATCHDOGFILE, "> watchdog-client.tmp") || die "Can not open file 'watchdog-client.tmp'!\n";
      print WATCHDOGFILE time() . "\n";
    close(WATCHDOGFILE);
    if($_[0] == 0){
      `mv watchdog-client.tmp watchdog-client.txt`;
    }
    $last_watchdog_call = time();
  }
}

