#! /usr/bin/perl
#Name: watchdog-R2-client.perl
#Project: Rover control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 09.04.2012
#Copyright: (c) 2012 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Script starts and observes the functionallity of R2-client.perl.

use strict;

#$|=1 ;


my $char_temp = "";
my @file_info;
my $current_timestamp = "";
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $CTIME_String = localtime(time);
my $last_watchdog_call = 0;
my @last_client_restart = (0, 0, 0, 0, 0);
my $i;


  `killall -s SIGKILL R2-client.perl`;
  sleep(2);
  `rm watchdog-client.tmp`;
  `rm watchdogclient.txt`;
  print "Starting R2 client.\n";
  system("./R2-client.perl&");
  print "Client started.\n";
  sleep(10);

  while(1 == 1){
    print "Checking...\n";
    if(!-e "watchdog-client.tmp"){#R2-client.perl is currently writing into file, so don't read timestamp now
      open(FILEIN, "< watchdog-client.txt") || die "Can not open file watchdog.txt!\n";
        $current_timestamp = <FILEIN>;
      close(FILEIN);
      if($current_timestamp > 1){
        if(time() - $current_timestamp > 35){#kill and restart R2-client.perl if last timestamp is too old
          print "Time (" . (time() - $current_timestamp) . ")exceeded - killing R2 client\n";
          &LogFile("Time limit exceeded!");
          `killall -s SIGKILL R2-client.perl`;
          sleep(5);
          print "Starting R2 client\n";
          system("./R2-client.perl&");
          for($i = 0; $i < 4; $i++){
            $last_client_restart[$i] = $last_client_restart[$i + 1];
          }
          $last_client_restart[4] = time();
          if($last_client_restart[4] - @last_client_restart[0] < 300){
            &LogFile("5 restarts in 5 minutes? Rebooting computer!");
            sleep(3);
            `lxde-reboot`;                        #Restart client computer
          }
        }
        else{
          print "Time difference = " . (time()-$current_timestamp) . " ok.\n";
        }
      }
      else{
        print "current_timestamp = '$current_timestamp'\n"
      }
    }#if(-e "watchdog.tmp"){
    sleep(40);
  }#while(1 == 1){


#++++++++++++++++++++++ LogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("R2-client.log");


  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv R2-client.log R2-client01.log`
  }

  open(LOGFILE, ">> R2-client.log") || die "Can not open file 'R2-client.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}
